#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private daaQRTiMAEnvelopeV1a[] cachedaaQRTiMAEnvelopeV1a;
		private daaQRTiSuperTrendV1b[] cachedaaQRTiSuperTrendV1b;
		private daaQRTiATR[] cachedaaQRTiATR;
		private daaQRTiEntryOrderPlots[] cachedaaQRTiEntryOrderPlots;
		private daaQRTiProfTrgtPlots[] cachedaaQRTiProfTrgtPlots;
		private daaQRTiStopLossPlots[] cachedaaQRTiStopLossPlots;
		private daaQRTiParabStopPlots[] cachedaaQRTiParabStopPlots;
		private daaQRTiEquityCurveMonitor[] cachedaaQRTiEquityCurveMonitor;

		
		public daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			return daaQRTiMAEnvelopeV1a(Input, pPeriod, pUpper_Pct, pLower_Pct, pRevZone_On, pRevZone_Upper_Ticks, pRevZone_Middle_Ticks, pRevZone_Lower_Ticks, pRevZone_Opacity);
		}

		public daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(int length, double multiplier, bool showArrows, bool showBackColor)
		{
			return daaQRTiSuperTrendV1b(Input, length, multiplier, showArrows, showBackColor);
		}

		public daaQRTiATR daaQRTiATR(int period)
		{
			return daaQRTiATR(Input, period);
		}

		public daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(int iD, int spacePixels)
		{
			return daaQRTiEntryOrderPlots(Input, iD, spacePixels);
		}

		public daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(int iD, int spacePixels)
		{
			return daaQRTiProfTrgtPlots(Input, iD, spacePixels);
		}

		public daaQRTiStopLossPlots daaQRTiStopLossPlots(int iD, int spacePixels)
		{
			return daaQRTiStopLossPlots(Input, iD, spacePixels);
		}

		public daaQRTiParabStopPlots daaQRTiParabStopPlots(int iD, int spacePixels)
		{
			return daaQRTiParabStopPlots(Input, iD, spacePixels);
		}

		public daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(int iD)
		{
			return daaQRTiEquityCurveMonitor(Input, iD);
		}


		
		public daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(ISeries<double> input, int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			if (cachedaaQRTiMAEnvelopeV1a != null)
				for (int idx = 0; idx < cachedaaQRTiMAEnvelopeV1a.Length; idx++)
					if (cachedaaQRTiMAEnvelopeV1a[idx].pPeriod == pPeriod && cachedaaQRTiMAEnvelopeV1a[idx].pUpper_Pct == pUpper_Pct && cachedaaQRTiMAEnvelopeV1a[idx].pLower_Pct == pLower_Pct && cachedaaQRTiMAEnvelopeV1a[idx].pRevZone_On == pRevZone_On && cachedaaQRTiMAEnvelopeV1a[idx].pRevZone_Upper_Ticks == pRevZone_Upper_Ticks && cachedaaQRTiMAEnvelopeV1a[idx].pRevZone_Middle_Ticks == pRevZone_Middle_Ticks && cachedaaQRTiMAEnvelopeV1a[idx].pRevZone_Lower_Ticks == pRevZone_Lower_Ticks && cachedaaQRTiMAEnvelopeV1a[idx].pRevZone_Opacity == pRevZone_Opacity && cachedaaQRTiMAEnvelopeV1a[idx].EqualsInput(input))
						return cachedaaQRTiMAEnvelopeV1a[idx];
			return CacheIndicator<daaQRTiMAEnvelopeV1a>(new daaQRTiMAEnvelopeV1a(){ pPeriod = pPeriod, pUpper_Pct = pUpper_Pct, pLower_Pct = pLower_Pct, pRevZone_On = pRevZone_On, pRevZone_Upper_Ticks = pRevZone_Upper_Ticks, pRevZone_Middle_Ticks = pRevZone_Middle_Ticks, pRevZone_Lower_Ticks = pRevZone_Lower_Ticks, pRevZone_Opacity = pRevZone_Opacity }, input, ref cachedaaQRTiMAEnvelopeV1a);
		}

		public daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(ISeries<double> input, int length, double multiplier, bool showArrows, bool showBackColor)
		{
			if (cachedaaQRTiSuperTrendV1b != null)
				for (int idx = 0; idx < cachedaaQRTiSuperTrendV1b.Length; idx++)
					if (cachedaaQRTiSuperTrendV1b[idx].Length == length && cachedaaQRTiSuperTrendV1b[idx].Multiplier == multiplier && cachedaaQRTiSuperTrendV1b[idx].ShowArrows == showArrows && cachedaaQRTiSuperTrendV1b[idx].ShowBackColor == showBackColor && cachedaaQRTiSuperTrendV1b[idx].EqualsInput(input))
						return cachedaaQRTiSuperTrendV1b[idx];
			return CacheIndicator<daaQRTiSuperTrendV1b>(new daaQRTiSuperTrendV1b(){ Length = length, Multiplier = multiplier, ShowArrows = showArrows, ShowBackColor = showBackColor }, input, ref cachedaaQRTiSuperTrendV1b);
		}

		public daaQRTiATR daaQRTiATR(ISeries<double> input, int period)
		{
			if (cachedaaQRTiATR != null)
				for (int idx = 0; idx < cachedaaQRTiATR.Length; idx++)
					if (cachedaaQRTiATR[idx].Period == period && cachedaaQRTiATR[idx].EqualsInput(input))
						return cachedaaQRTiATR[idx];
			return CacheIndicator<daaQRTiATR>(new daaQRTiATR(){ Period = period }, input, ref cachedaaQRTiATR);
		}

		public daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(ISeries<double> input, int iD, int spacePixels)
		{
			if (cachedaaQRTiEntryOrderPlots != null)
				for (int idx = 0; idx < cachedaaQRTiEntryOrderPlots.Length; idx++)
					if (cachedaaQRTiEntryOrderPlots[idx].ID == iD && cachedaaQRTiEntryOrderPlots[idx].SpacePixels == spacePixels && cachedaaQRTiEntryOrderPlots[idx].EqualsInput(input))
						return cachedaaQRTiEntryOrderPlots[idx];
			return CacheIndicator<daaQRTiEntryOrderPlots>(new daaQRTiEntryOrderPlots(){ ID = iD, SpacePixels = spacePixels }, input, ref cachedaaQRTiEntryOrderPlots);
		}

		public daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(ISeries<double> input, int iD, int spacePixels)
		{
			if (cachedaaQRTiProfTrgtPlots != null)
				for (int idx = 0; idx < cachedaaQRTiProfTrgtPlots.Length; idx++)
					if (cachedaaQRTiProfTrgtPlots[idx].ID == iD && cachedaaQRTiProfTrgtPlots[idx].SpacePixels == spacePixels && cachedaaQRTiProfTrgtPlots[idx].EqualsInput(input))
						return cachedaaQRTiProfTrgtPlots[idx];
			return CacheIndicator<daaQRTiProfTrgtPlots>(new daaQRTiProfTrgtPlots(){ ID = iD, SpacePixels = spacePixels }, input, ref cachedaaQRTiProfTrgtPlots);
		}

		public daaQRTiStopLossPlots daaQRTiStopLossPlots(ISeries<double> input, int iD, int spacePixels)
		{
			if (cachedaaQRTiStopLossPlots != null)
				for (int idx = 0; idx < cachedaaQRTiStopLossPlots.Length; idx++)
					if (cachedaaQRTiStopLossPlots[idx].ID == iD && cachedaaQRTiStopLossPlots[idx].SpacePixels == spacePixels && cachedaaQRTiStopLossPlots[idx].EqualsInput(input))
						return cachedaaQRTiStopLossPlots[idx];
			return CacheIndicator<daaQRTiStopLossPlots>(new daaQRTiStopLossPlots(){ ID = iD, SpacePixels = spacePixels }, input, ref cachedaaQRTiStopLossPlots);
		}

		public daaQRTiParabStopPlots daaQRTiParabStopPlots(ISeries<double> input, int iD, int spacePixels)
		{
			if (cachedaaQRTiParabStopPlots != null)
				for (int idx = 0; idx < cachedaaQRTiParabStopPlots.Length; idx++)
					if (cachedaaQRTiParabStopPlots[idx].ID == iD && cachedaaQRTiParabStopPlots[idx].SpacePixels == spacePixels && cachedaaQRTiParabStopPlots[idx].EqualsInput(input))
						return cachedaaQRTiParabStopPlots[idx];
			return CacheIndicator<daaQRTiParabStopPlots>(new daaQRTiParabStopPlots(){ ID = iD, SpacePixels = spacePixels }, input, ref cachedaaQRTiParabStopPlots);
		}

		public daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(ISeries<double> input, int iD)
		{
			if (cachedaaQRTiEquityCurveMonitor != null)
				for (int idx = 0; idx < cachedaaQRTiEquityCurveMonitor.Length; idx++)
					if (cachedaaQRTiEquityCurveMonitor[idx].ID == iD && cachedaaQRTiEquityCurveMonitor[idx].EqualsInput(input))
						return cachedaaQRTiEquityCurveMonitor[idx];
			return CacheIndicator<daaQRTiEquityCurveMonitor>(new daaQRTiEquityCurveMonitor(){ ID = iD }, input, ref cachedaaQRTiEquityCurveMonitor);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			return indicator.daaQRTiMAEnvelopeV1a(Input, pPeriod, pUpper_Pct, pLower_Pct, pRevZone_On, pRevZone_Upper_Ticks, pRevZone_Middle_Ticks, pRevZone_Lower_Ticks, pRevZone_Opacity);
		}

		public Indicators.daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(int length, double multiplier, bool showArrows, bool showBackColor)
		{
			return indicator.daaQRTiSuperTrendV1b(Input, length, multiplier, showArrows, showBackColor);
		}

		public Indicators.daaQRTiATR daaQRTiATR(int period)
		{
			return indicator.daaQRTiATR(Input, period);
		}

		public Indicators.daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiEntryOrderPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiProfTrgtPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiStopLossPlots daaQRTiStopLossPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiStopLossPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiParabStopPlots daaQRTiParabStopPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiParabStopPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(int iD)
		{
			return indicator.daaQRTiEquityCurveMonitor(Input, iD);
		}


		
		public Indicators.daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(ISeries<double> input , int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			return indicator.daaQRTiMAEnvelopeV1a(input, pPeriod, pUpper_Pct, pLower_Pct, pRevZone_On, pRevZone_Upper_Ticks, pRevZone_Middle_Ticks, pRevZone_Lower_Ticks, pRevZone_Opacity);
		}

		public Indicators.daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(ISeries<double> input , int length, double multiplier, bool showArrows, bool showBackColor)
		{
			return indicator.daaQRTiSuperTrendV1b(input, length, multiplier, showArrows, showBackColor);
		}

		public Indicators.daaQRTiATR daaQRTiATR(ISeries<double> input , int period)
		{
			return indicator.daaQRTiATR(input, period);
		}

		public Indicators.daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiEntryOrderPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiProfTrgtPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiStopLossPlots daaQRTiStopLossPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiStopLossPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiParabStopPlots daaQRTiParabStopPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiParabStopPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(ISeries<double> input , int iD)
		{
			return indicator.daaQRTiEquityCurveMonitor(input, iD);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			return indicator.daaQRTiMAEnvelopeV1a(Input, pPeriod, pUpper_Pct, pLower_Pct, pRevZone_On, pRevZone_Upper_Ticks, pRevZone_Middle_Ticks, pRevZone_Lower_Ticks, pRevZone_Opacity);
		}

		public Indicators.daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(int length, double multiplier, bool showArrows, bool showBackColor)
		{
			return indicator.daaQRTiSuperTrendV1b(Input, length, multiplier, showArrows, showBackColor);
		}

		public Indicators.daaQRTiATR daaQRTiATR(int period)
		{
			return indicator.daaQRTiATR(Input, period);
		}

		public Indicators.daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiEntryOrderPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiProfTrgtPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiStopLossPlots daaQRTiStopLossPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiStopLossPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiParabStopPlots daaQRTiParabStopPlots(int iD, int spacePixels)
		{
			return indicator.daaQRTiParabStopPlots(Input, iD, spacePixels);
		}

		public Indicators.daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(int iD)
		{
			return indicator.daaQRTiEquityCurveMonitor(Input, iD);
		}


		
		public Indicators.daaQRTiMAEnvelopeV1a daaQRTiMAEnvelopeV1a(ISeries<double> input , int pPeriod, double pUpper_Pct, double pLower_Pct, bool pRevZone_On, double pRevZone_Upper_Ticks, double pRevZone_Middle_Ticks, double pRevZone_Lower_Ticks, int pRevZone_Opacity)
		{
			return indicator.daaQRTiMAEnvelopeV1a(input, pPeriod, pUpper_Pct, pLower_Pct, pRevZone_On, pRevZone_Upper_Ticks, pRevZone_Middle_Ticks, pRevZone_Lower_Ticks, pRevZone_Opacity);
		}

		public Indicators.daaQRTiSuperTrendV1b daaQRTiSuperTrendV1b(ISeries<double> input , int length, double multiplier, bool showArrows, bool showBackColor)
		{
			return indicator.daaQRTiSuperTrendV1b(input, length, multiplier, showArrows, showBackColor);
		}

		public Indicators.daaQRTiATR daaQRTiATR(ISeries<double> input , int period)
		{
			return indicator.daaQRTiATR(input, period);
		}

		public Indicators.daaQRTiEntryOrderPlots daaQRTiEntryOrderPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiEntryOrderPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiProfTrgtPlots daaQRTiProfTrgtPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiProfTrgtPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiStopLossPlots daaQRTiStopLossPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiStopLossPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiParabStopPlots daaQRTiParabStopPlots(ISeries<double> input , int iD, int spacePixels)
		{
			return indicator.daaQRTiParabStopPlots(input, iD, spacePixels);
		}

		public Indicators.daaQRTiEquityCurveMonitor daaQRTiEquityCurveMonitor(ISeries<double> input , int iD)
		{
			return indicator.daaQRTiEquityCurveMonitor(input, iD);
		}

	}
}

#endregion
